<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Equipment ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Equipment extends AbstractStructArrayBase
{
    /**
     * The Equipment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Equipment[]
     */
    public $Equipment;
    /**
     * Constructor method for ArrayOfJP_Equipment
     * @uses ArrayOfJP_Equipment::setEquipment()
     * @param \StructType\JP_Equipment[] $equipment
     */
    public function __construct(array $equipment = array())
    {
        $this
            ->setEquipment($equipment);
    }
    /**
     * Get Equipment value
     * @return \StructType\JP_Equipment[]|null
     */
    public function getEquipment()
    {
        return $this->Equipment;
    }
    /**
     * Set Equipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Equipment[] $equipment
     * @return \ArrayType\ArrayOfJP_Equipment
     */
    public function setEquipment(array $equipment = array())
    {
        foreach ($equipment as $arrayOfJP_EquipmentEquipmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_EquipmentEquipmentItem instanceof \StructType\JP_Equipment) {
                throw new \InvalidArgumentException(sprintf('The Equipment property can only contain items of \StructType\JP_Equipment, "%s" given', is_object($arrayOfJP_EquipmentEquipmentItem) ? get_class($arrayOfJP_EquipmentEquipmentItem) : gettype($arrayOfJP_EquipmentEquipmentItem)), __LINE__);
            }
        }
        $this->Equipment = $equipment;
        return $this;
    }
    /**
     * Add item to Equipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Equipment $item
     * @return \ArrayType\ArrayOfJP_Equipment
     */
    public function addToEquipment(\StructType\JP_Equipment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Equipment) {
            throw new \InvalidArgumentException(sprintf('The Equipment property can only contain items of \StructType\JP_Equipment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Equipment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Equipment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Equipment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Equipment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Equipment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Equipment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Equipment
     */
    public function getAttributeName()
    {
        return 'Equipment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Equipment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
